; ONE-AT-A-TIME LASER LABELS  
;
; Copyright (c) 1992 by                            

;    Donald Dunn                          
;    Free Spirit Writing & Photography    
;    6337 Dorchester Ct.                  
;    Carmichael, CA  95608                
;                                                    
;    (916) 944-0798                       
;                                                    
; Permission is granted to use this code in any ap-  
; plication you may create so long as the copyright  
; notice is retained.                                
;                                                    
; All HP commands begin with CHR(027). In order to  
; print this listing on an HP printer without execut-
; ing the commands, change all CHR(027) to something 
; else, such as '#' in this listing. (# doesn't      
; appear anywhere else in this listing.)            
;__________________________________________________________________________
; FUNCTION: test printer ready, allow escape
;__________________________________________________________________________

PROC PRINTER_status()
WHILE(True)
  IF PRINTERSTATUS() THEN
    RETURN "ready"                   ; send'm away happy
  ELSE
    MESSAGE "Press [Enter] when printer is ready, [Esc] to exit"
    WHILE CHARWAITING()              ; discard any type aheads
      x = GETCHAR()
    ENDWHILE
    x = GETCHAR()                    ; get their response
    MESSAGE " "                      ; clear message area
    IF x = 13 THEN LOOP ENDIF        ; found ENTER
    IF x = 27 THEN RETURN "exit"     ; found ESC
    ENDIF
    MESSAGE "Not a choice, please try again"
  ENDIF
ENDWHILE
ENDPROC

IF PRINTER_status() = "exit" THEN RETURN 0 ENDIF

x_start = 38          ; horz dots to first label
y_start = 75          ; vert dots to first label
x_long  = 300*(2+3/4) ; horz dots wide/label 2+5/8"(2.75 with GAP)
y_long  = 300         ; vert dots high/label 1"
columns_per_page = 3
rows_per_page    = 10
hp_page  = CHR(27)+"&l0H"    ; page eject
hp_reset = CHR(27)+"E"       ; reset printer
page_waiting = "N"    ; any pages waiting to print?

CURSOR OFF CLEAR @ 0,0
TEXT
                           ADDRESS LABEL PRINTING


This routine will print laser printer address labels.  It can start in the
middle of a partially used page.  It won't print anything until a page
is full or you say you are done.

                               INSERT FORM 5160

                          Press any key to continue.
ENDTEXT

PAINTCANVAS ATTRIBUTE 15 + 48 0,0,  24,79
ACCEPT "a1" TO yesorno
CLEAR CURSOR normal
@ 0,0

TEXT
                           ADDRESS LABEL PRINTING


               PRINTER            
     
              1     2     3        Columns
       Ŀ
   1         :     :     :                 Decide if you have a fresh
       - - - - - - - - - - - - -           starting page or a partial
   2         :     :     :                 page then answer these two
       - - - - - - - - - - - - -           questions:
   3         :     :     :      
       - - - - - - Ĵ           Starting row   :
             :          :                 Starting column:
   R   Ĵ
   o         :          :                 Just hit enter if full page
   w   Ĵ
             :          :      
       
ENDTEXT

PAINTCANVAS ATTRIBUTE 15 + 48 0,0, 24,79
PAINTCANVAS ATTRIBUTE 1 + 112  12,63, 12,68  ; blue/lt. gray
PAINTCANVAS ATTRIBUTE 1 + 112  13,63, 13,68  ; blue/lt. gray

CANVAS ON
@ 12, 63
ACCEPT "s" MIN 1 MAX rows_per_page DEFAULT 1 TO current_row
@ 13, 63
ACCEPT "s" MIN 1 MAX columns_per_page DEFAULT 1 TO current_column

; HP SET UP _______________________________________________

OPEN PRINTER
PRINT hp_reset
; Primary font
PRINT CHR(27)+"(8U"  ; roman-8, proportional, pt 12, style up,solid
; Medium weight CG Times
PRINT CHR(27)+"(s1p12v0s0b4101T"

; SELECT CUSTOMERS FOR LABELS _____________________________

CLEAR
VIEW "Customer"
WHILE(True)
  WAIT TABLE
    PROMPT
    "[F2] Select Customer for label, [Esc] - Exit and print waiting labels"
    UNTIL "F2","ESC"
  IF RETVAL = "ESC" THEN QUITLOOP ENDIF
  MESSAGE "Customer selected for label"
  page_waiting = "Y"

  ; START OF ONE LABEL ___________________________________
  ynow = y_start+(current_row-1)*y_long                 ;|
  xnow = x_start+(current_column-1)*x_long              ;|
  PRINT CHR(27)+"*p" + STRVAL(ynow) + "Y"                      ;|
  PRINT CHR(27)+"*p" + STRVAL(xnow) + "X"                      ;|
  IF [attnname] <> "" THEN                              ;|
    PRINT "Attn: " + [attnname] + "\n"                  ;|
  ENDIF                                                 ;|

  PRINT CHR(27)+"*p" + STRVAL(xnow) + "X"                      ;|
  PRINT [name] + "\n"                                   ;|
  PRINT CHR(27)+"*p" + STRVAL(xnow) + "X"                      ;|
  PRINT [addr1] + "\n"                                  ;|
  IF [addr2] <> "" THEN                                 ;|
    PRINT CHR(27)+"*p" + STRVAL(xnow) + "X"                    ;|
    PRINT [addr2] + "\n"                                ;|
  ENDIF                                                 ;|
  PRINT CHR(27)+"*p" + STRVAL(xnow) + "X"                      ;|
  IF ISBLANK([country]) THEN                            ;|
    country = ""                                        ;|
  ELSE                                                  ;|
    country = [country] + " "                           ;|
  ENDIF                                                 ;|
  IF ISBLANK([zip+4]) THEN                              ;|
    zip = [zip]                                         ;|
  ELSE                                                  ;|
    zip = [zip] + "-" + [zip+4]                         ;|
  ENDIF                                                 ;|
  PRINT [city] + ", " + [state] +                       ;|
  " " + country + zip +"\n"                             ;|
  ; END OF ONE LABEL _____________________________________
  current_column = current_column + 1
  IF current_column > columns_per_page THEN ;exceeded columns
    current_column = 1
    current_row = current_row + 1
  ENDIF
  IF current_row > rows_per_page THEN     ; page is full, print
    PRINT hp_page
    current_row = 1                       ; reset row pointer
    page_waiting = "N"                    ; nothing left to print
  ENDIF
ENDWHILE

IF page_waiting = "Y" THEN   ; anything left to print?
  PRINT hp_page              ; yes, page eject
ENDIF

CLEARALL
PRINT hp_reset               ; remove anything we changed
CLOSE PRINTER
